#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"dxguid.lib")
#pragma comment(lib,"dsound.lib")
#pragma comment(lib,"vorbisfile_static.lib")
#pragma comment(lib,"vorbis_static.lib")
#pragma comment(lib,"ogg_static.lib")
#include <windows.h>
#include <dsound.h>
#include <stdio.h>
#include <malloc.h>
#include <process.h>
#include "vorbis/vorbisfile.h"
//W̃CN[hpXɓ̂̂ŁAƏĂ܂B
// <>  "" ɕςB

//----------------------------
//GNX|[g֐
//----------------------------
extern "C" {
	__declspec(dllexport) void Initialize (LPDIRECTSOUND p_lpds);
	//Xg[~OCu
	__declspec(dllexport) void Finalize (void);
	//Xg[~OCuI
	__declspec(dllexport) bool Open (int num,char *filename,int offset,int length);
	//t@CI[vBItZbgƃt@C̒𗼕ƂOɂƃt@CŚA
	//ǂ炩łOȊOƃt@C̈ꕔĐB
	__declspec(dllexport) void Close (int num);
	//t@CB
	__declspec(dllexport) bool Play (int num,bool islp);
	//ĐBXbh𐶐B
	__declspec(dllexport) bool IsPlaying (int num);
	//ĐĂ邩ǂ𒲂ׂB
	__declspec(dllexport) void Volume (int num,int vol);
	//{[ωB

	__declspec(dllexport) void OggInitialize (HWND hwnd);
	//EBhEnhgăXg[~OCu
	__declspec(dllexport) void OggFinalize (void);
	//nhŏI

	__declspec(dllexport) bool Play2 (int num,double loop_point);
	//[vɂǂɖ߂邩włBOggł̂ݎgB
}


//ov_open_callbackɐH킹邽߂̍\́^֐
struct FILE2 {
	FILE *fp;
	long ofs;
	long len;
	long readbyte;
};

void FILE2Open (FILE2 *p,FILE *f,int o,int l);
size_t FILE2Read (void *buf, size_t size, size_t count, void *file2);
int FILE2Seek (void *file2, ogg_int64_t num, int param);
int FILE2Close (void *file2);
long FILE2Tell (void *file2);

ov_callbacks callbacks={
	(size_t (*)(void *,size_t,size_t,void *)) FILE2Read,
	(int (*)(void *,ogg_int64_t,int)) FILE2Seek,
	(int (*)(void *)) FILE2Close,
	(long (*)(void *)) FILE2Tell
};

//XbhĂяo֐
void playfunc (void *voidptr);

const int CHMAX=200;
LPDIRECTSOUND lpds;

LPDIRECTSOUNDBUFFER dsprbf;
BOOL FromHandle=FALSE;

volatile int lpstatus=0;
uintptr_t lpthr=0;
void lpplayfunc (void *voidptr);


class Channel {
public:
	FILE *fp;
	FILE2 f2;
	char fname[256];
	OggVorbis_File vf;
	vorbis_info *vi;
	int fileoffset;
	int filelength;
	double lppt;
	LPDIRECTSOUNDBUFFER dsbf;
	LPDIRECTSOUNDNOTIFY dsnf;
	WAVEFORMATEX wfex;
	int iCurrentSection;
	int buffersize;
	bool isloop;
	uintptr_t thr;
	volatile int thrstatus;//0 Xbh͎s 1 ~҂ 2 ~
	int zeroround;//obt@ɂO񂾉񐔁iImpj
	int filetype;//0=WAVE PCM 1=WAVE PCMȊO 2=OGG
	int datasize;//WAVE[hŎg߂́Af[^`ÑTCY
	int readbyte;//WAVE[hŁAɓǂݍ񂾃oCg
	int datastart;//WAVE[hŎgAf[^`N̐擪ItZbg
	HANDLE file;//WAVEp@Xbht@Cǂݍނ̂Ɏgt@Cnh

	void Initialize (void);
	void Finalize (void);
	bool Open (char *filename,int offset,int length);
	void Close (void);
	bool Play (bool islp);
	bool Play2 (double loop_point);
	bool IsPlaying (void);
	void Volume (int vol);

//̕ӂ͓p֐
	void seek_data(FILE *fp);
	bool WriteData(char *ptr1,DWORD byte1,char *ptr2,DWORD byte2);
	bool ov_read_wrapper (char *ptr,int size);
	bool pcm_read_wrapper (char *ptr,int size);

} ch[CHMAX];

void Channel::Initialize(void) {
	fileoffset=0;
	filelength=0;
	fp=NULL;
	vi=NULL;
	dsbf=NULL;
	thr=0;
	filetype=0;
	file=NULL;
}

void Channel::Finalize(void) {
	Close();
}

void Initialize (LPDIRECTSOUND p_lpds) {
	lpds=p_lpds;
	for (int i=0;i<CHMAX;i++) {
		ch[i].Initialize();
	}
	return;
}

void OggInitialize (HWND wnd) {
	FromHandle=TRUE;
	HRESULT hr=::DirectSoundCreate(NULL,&lpds,NULL);
	lpds->SetCooperativeLevel(wnd,DSSCL_PRIORITY);
	DSBUFFERDESC dsbdesc;
	::ZeroMemory(&dsbdesc, sizeof(DSBUFFERDESC));
	dsbdesc.dwSize = sizeof(DSBUFFERDESC);
	dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER ;
	dsbdesc.dwBufferBytes = 0;
	dsbdesc.lpwfxFormat = NULL;
	lpds->CreateSoundBuffer(&dsbdesc, &dsprbf, NULL);
	WAVEFORMATEX prwfx;
	prwfx.wFormatTag = WAVE_FORMAT_PCM;
	prwfx.cbSize=sizeof(WAVEFORMATEX);
	prwfx.nChannels = 2;
	prwfx.nSamplesPerSec = 44100;
	prwfx.wBitsPerSample = 16;
	prwfx.nBlockAlign = prwfx.nChannels * prwfx.wBitsPerSample / 8;
	prwfx.nAvgBytesPerSec=prwfx.nSamplesPerSec * prwfx.nBlockAlign;
	dsprbf->SetFormat(&prwfx);
	for (int i=0;i<CHMAX;i++) {
		ch[i].Initialize();
	}
}


void OggFinalize (void) {
	for (int i=0;i<CHMAX;i++) {
		ch[i].Finalize();
	}
	dsprbf->Release();
	lpds->Release();
}

void Finalize (void) {
	for (int i=0;i<CHMAX;i++) {
		ch[i].Finalize();
	}
}


void Channel::seek_data (FILE *fp) {
	while(1) {
		int c;
		c=fgetc(fp);
		if (c!='d') continue;
		c=fgetc(fp);
		if (c!='a') continue;
		c=fgetc(fp);
		if (c!='t') continue;
		c=fgetc(fp);
		if (c!='a') continue;
		fread(&datasize,4,1,fp);
		readbyte=0;
		datastart=ftell(fp);
		break;
	}
}

bool Open (int num,char *filename,int offset,int length) {
	return ch[num].Open(filename,offset,length);
}


bool Channel::Open (char *filename,int offset,int length) {
	DSBUFFERDESC dsbdesc;
	char checkbuf[5];
	if (fp) {
		Close();
	}
	fileoffset=offset;
	filelength=length;
	::ZeroMemory(&dsbdesc, sizeof(DSBUFFERDESC));
	dsbdesc.dwSize = sizeof(DSBUFFERDESC);
	dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER ;
	dsbdesc.dwBufferBytes = 0;
	dsbdesc.lpwfxFormat = NULL;
	dsbdesc.dwFlags = DSBCAPS_CTRLPAN | 
	DSBCAPS_CTRLVOLUME | 
	DSBCAPS_CTRLFREQUENCY | 
	DSBCAPS_CTRLPOSITIONNOTIFY |
	DSBCAPS_GLOBALFOCUS ;
	ZeroMemory(&wfex,sizeof(wfex));
	strcpy (fname,filename);
	fp=fopen(filename,"rb");
	if (fp==NULL) return false;
	if (offset!=0 || length!=0) {
		fseek(fp,offset,SEEK_SET);
	}

	//t@C^CvʂB
	fread (checkbuf,4,1,fp);
	if (
		checkbuf[0]=='R' && 
		checkbuf[1]=='I' && 
		checkbuf[2]=='F' 
		&& checkbuf[3]=='F') {
		//WAVEt@CƔfB
		fseek(fp,16,SEEK_CUR);
		fread(checkbuf,2,1,fp);
		if (checkbuf[0]==0x01 && checkbuf[1]==0x00) {
			filetype=0;//WAVE PCM
		} else {
			return false;//ACMn͂߂ǂ̂őΉȂ
		}
	} else {
		filetype=1;//OGGt@CƔfB
		if (offset!=0 || length!=0) {
			FILE2Open(&f2,fp,offset,length);
			fp=NULL;//Ȃ
		} else {
			fseek (fp,0,SEEK_SET);
		}
	}
	if (filetype==0) {
		//PCM
		ZeroMemory(&wfex,sizeof(wfex));
		wfex.wFormatTag = WAVE_FORMAT_PCM;
		wfex.cbSize=sizeof(WAVEFORMATEX);
		fread(&wfex.nChannels,2,1,fp);
		fread(&wfex.nSamplesPerSec,4,1,fp);
		fread(&wfex.nAvgBytesPerSec,4,1,fp);
		fread(&wfex.nBlockAlign,2,1,fp);
		fread(&wfex.wBitsPerSample,2,1,fp);
		dsbdesc.lpwfxFormat=&wfex;
		seek_data(fp);
		buffersize=dsbdesc.dwBufferBytes=wfex.nAvgBytesPerSec*2;
		file=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		SetFilePointer(file,datastart,0,FILE_BEGIN);
		fclose(fp);
		fp=NULL;//Ȃ
		if (file==NULL) {
			return false;
		}
	} else if (filetype==1) {
		int ret;
		if (offset!=0 || length!=0) {
			ov_open_callbacks(&f2,&vf,NULL,0,callbacks);
			if (ret<0) {
				FILE2Close(&f2);
				return false;
			}
		} else {
			ov_open(fp,&vf,NULL,0);
			if (ret<0) {
				fclose(fp);
				fp=NULL;
				return false;
			}
			fp=NULL;//Ȃ
		}

		vi=ov_info(&vf,-1);
		if (!vi) {
			ov_clear(&vf);
			return false;
		}
		//DirectSoundBuffer
		wfex.wFormatTag = WAVE_FORMAT_PCM;
		wfex.cbSize=sizeof(WAVEFORMATEX);
		wfex.nChannels = vi->channels;
		wfex.nSamplesPerSec = vi->rate;
		wfex.wBitsPerSample = 16;
		wfex.nBlockAlign = wfex.nChannels * wfex.wBitsPerSample / 8;
		wfex.nAvgBytesPerSec=wfex.nSamplesPerSec * wfex.nBlockAlign;
		dsbdesc.lpwfxFormat=&wfex;
		buffersize=dsbdesc.dwBufferBytes=wfex.nAvgBytesPerSec*2;
		//UifR[hƓXbhŊJȂ΂Ȃ炵j
		ov_clear(&vf);
		fp=fopen(filename,"rb");
		if (fp==NULL) return false;
		if (offset!=0 || length!=0) {
			fseek(fp,offset,SEEK_SET);
			FILE2Open(&f2,fp,offset,length);
			fp=NULL;
		}
	}
	unsigned int err;
	err=lpds->CreateSoundBuffer(&dsbdesc,&dsbf,NULL);
	if (!SUCCEEDED(err)) {
		dsbf=NULL;
		if (fp!=NULL) {
			fclose(fp);
			fp=NULL;
		}
		return false;
	}
	Volume(0);
	return true;
}

void Close (int num) {
	ch[num].Close();
}


void Channel::Close () {
	if (thr) {
		if (thrstatus==0) {
			thrstatus=1;
			while (thrstatus!=2) {
				Sleep(1);//I̓Xs[fBȕKvB
			}
			Sleep(0);
			//endthreadOɂ̉sĂ܂Ƃ肤̂ŁA
			//ꉞSleep(0)ĂB
			//thestatusɑĂendthread܂łɂ͏ȂA
			//̉̑ƏՓ˂Sz͂Ȃ̂ŁAȂB
		}
	}
	if (fp) {
		fclose(fp);
	}
	if (vf.vi) {
		ov_clear(&vf);
	}
	if (file) {
		CloseHandle(file);
	}
	Initialize();
	return;
}

bool Play (int num,bool islp) {
	return ch[num].Play(islp);
}

bool Play2 (int num,double loop_point) {
	return ch[num].Play2(loop_point);
}


bool Channel::Play (bool islp) {
	if (dsbf==NULL) return false;
	isloop=islp;
	lppt=0;
	thrstatus=0;
	zeroround=0;
	thr=_beginthread(playfunc,0,(void *)this);
	return true;
}

bool Channel::Play2 (double looppoint) {
	if (dsbf==NULL) return false;
	isloop=true;
	lppt=looppoint;
	thrstatus=0;
	zeroround=0;
	thr=_beginthread(playfunc,0,(void *)this);
	return true;
}


void playfunc (void *voidptr) {
	DWORD end;
	DWORD cur;
	char *ptr1,*ptr2;
	Channel *pch=(Channel *)voidptr;
	if (pch->filetype==1) {
		//߂oggJȂ
		if (pch->fp) {
			ov_open(pch->fp,&pch->vf,NULL,0);
		} else if (pch->f2.fp) {
			ov_open_callbacks(&pch->f2,&pch->vf,NULL,0,callbacks);
		}
		pch->vi=ov_info(&pch->vf,-1);
	}
_replay:
	DWORD byte1,byte2;
//	if(FAILED(pch->dsbf->QueryInterface(IID_IDirectSoundNotify,(void**)&pch->dsnf))) {
//		goto _end_thr;
//	}
	HRESULT hr; 
	hr=pch->dsbf->Lock(0,pch->wfex.nAvgBytesPerSec,(LPVOID *)&ptr1,&byte1,(LPVOID *)&ptr2,&byte2,0);
	if (hr==DSERR_BUFFERLOST) {
		pch->dsbf->Restore();
		hr=pch->dsbf->Lock(0,pch->wfex.nAvgBytesPerSec,(LPVOID *)&ptr1,&byte1,(LPVOID *)&ptr2,&byte2,0);
	}
	if (!SUCCEEDED(hr)) goto _end_thr;
	end=byte1;
	pch->WriteData(ptr1,byte1,ptr2,byte2);
	pch->dsbf->Unlock((LPVOID *)ptr1,byte1,(LPVOID *)ptr2,byte2);

	pch->dsbf->Play(0,0,DSBPLAY_LOOPING);
	bool rewind=false;
	while (1) {
		if (pch->thrstatus==1) break;
		hr=pch->dsbf->Lock(end,pch->wfex.nAvgBytesPerSec,(LPVOID *)&ptr1,&byte1,(LPVOID *)&ptr2,&byte2,0);
		if (hr==DSERR_BUFFERLOST) {
			pch->dsbf->Restore();
			hr=pch->dsbf->Lock(end,pch->wfex.nAvgBytesPerSec,(LPVOID *)&ptr1,&byte1,(LPVOID *)&ptr2,&byte2,0);
		}
		if (!SUCCEEDED(hr)) {
			break;
		}
		if (byte1==0 && byte2==0) {
			pch->dsbf->Unlock((LPVOID *)ptr1,byte1,(LPVOID *)ptr2,byte2);
			break;
		}
		pch->WriteData(ptr1,byte1,ptr2,byte2);
		pch->dsbf->Unlock((LPVOID *)ptr1,byte1,(LPVOID *)ptr2,byte2);
		if (pch->zeroround>2) {
			if (pch->isloop) {
				//́AV[NłȂƂƂ
				pch->dsbf->Stop();
				pch->dsbf->SetCurrentPosition(0);
				ov_clear(&pch->vf);
				if (pch->fileoffset==0 && pch->filelength==0) {
					//ɂ͂Ȃ͂Ȃ񂾂ǈꉞgłB
					pch->fp=fopen(pch->fname,"rb");
					ov_open(pch->fp,&pch->vf,NULL,0);
					goto _replay;
				} else {
					pch->fp=fopen(pch->fname,"rb");
					FILE2Open(&pch->f2,pch->fp,pch->fileoffset,pch->filelength);
					pch->fp=NULL;
					ov_open_callbacks(&pch->f2,&pch->vf,NULL,0,callbacks);
				}
				pch->vi=ov_info(&pch->vf,-1);
				pch->zeroround=0;
				goto _replay;
			}
			pch->dsbf->Stop();
			break;
		}
		DWORD beforecur=0;
		while (1) {
			pch->dsbf->GetCurrentPosition(&cur,NULL);
			if (!rewind && cur>end) break;
			if (rewind && cur<=beforecur) {
				rewind=false;
			}
			beforecur=cur;
			//Qbȏ͗]T邩Aꎩ̂͂̂тł͂A
			//IɊԂ̂͂܂̂ŁAKxɃ`FbN͂ށB
			//ŁAPO~bȓɉI邱Ƃۏ؂B
			for (int i=0;i<10;i++) {
				Sleep(10);
				if (pch->thrstatus==1) break;
			}
			if (pch->thrstatus==1) break;
		}
		if (pch->thrstatus==1) break;
		if (byte2>0) {
			end=byte2;
			rewind=true;
		} else {
			end=end+byte1;
			if (end==pch->buffersize) {
				end=0;
				rewind=true;
			} else {
                rewind=false;
			}
		}
	}
_end_thr:
	pch->dsbf->Stop();
	pch->dsbf->Release();
	pch->dsbf=NULL;
	pch->thrstatus=2;
	_endthread();
}

bool IsPlaying (int num) {
	return ch[num].IsPlaying();
}

bool Channel::IsPlaying (void) {
	if (dsbf) return true;
	return false;
}

void Volume (int num,int vol) {
	ch[num].Volume(vol);
}


void Channel::Volume (int vol) {
	if (dsbf==NULL) return;
	dsbf->SetVolume(vol);
	return;
}

bool Channel::WriteData(char *ptr1,DWORD byte1,char *ptr2,DWORD byte2) {
	if (filetype==0) {
		if (!pcm_read_wrapper(ptr1,byte1)) {
			zeroround++;
			return false;
		}
		if (ptr2==NULL) return true;
		if (!pcm_read_wrapper(ptr2,byte2)) {
			zeroround++;
			return false;
		}
	} else if (filetype==1) {
		if (!ov_read_wrapper(ptr1,byte1)) {
			zeroround++;
			return false;
		}
		if (ptr2==NULL) return true;
		if (!ov_read_wrapper(ptr2,byte2)) {
			zeroround++;
			return false;
		}
	}
	return true;
}

bool Channel::ov_read_wrapper (char *ptr,int size) {
	DWORD ptroffset=0,ws;
	while (1) {
		ws=ov_read(&vf,ptr+ptroffset,size-ptroffset,0,2,1,&iCurrentSection);
		ptroffset+=ws;
		if (ptroffset>=size) break;
		if (ws<=0) {
		//ǂݏI
			if (isloop) {
				if (ov_time_seek(&vf,lppt)!=0) {
					memset (ptr+ptroffset,0,size-ptroffset);
					return false;
				}
				continue;
			} else {
				memset (ptr+ptroffset,0,size-ptroffset);
				return false;
			}
		}
	}
	return true;
}

bool Channel::pcm_read_wrapper (char *ptr,int size) {
	DWORD ws;
	int sz;
_lp:
	if (size+readbyte>=datasize) {
		//t@CIĂ܂̂ŏ
		sz=datasize-readbyte;
	} else sz=size;
	ReadFile(file,ptr,sz,&ws,NULL);
	readbyte+=ws;
	if (ws<size) {
		if (isloop) {
			SetFilePointer(file,datastart+(int)(((lppt*(double)wfex.nAvgBytesPerSec)/wfex.nBlockAlign)*wfex.nBlockAlign),0,FILE_BEGIN);
			readbyte=0;
			size-=ws;
			ptr+=ws;
			goto _lp;
		} else {
			if (wfex.wBitsPerSample==16) {
				memset (ptr+ws,0,size-ws);
			} else if (wfex.wBitsPerSample==8) {
				memset (ptr+ws,0x80,size-ws);
			}
			return false;
		}
	}
	return true;
}

void FILE2Open (FILE2 *p,FILE *f,int o,int l) {
	p->fp=f;
	p->len=l;
	p->ofs=o;
	p->readbyte=0;
	fseek(f,o,SEEK_SET);
}

size_t FILE2Read (void *buf, size_t size, size_t count, void *file2) {
	FILE2 *f=(FILE2 *)file2;
	int co=count;
	if (size*co>f->len-f->readbyte) {
		co=(f->len-f->readbyte)/size;
	}
	if (co<=0) return 0;//ɂǂ߂Ȃ
	int ret=fread(buf,size,co,f->fp);
	f->readbyte+=(ret*size);
	return ret;
}
int FILE2Seek (void *file2, ogg_int64_t num, int param) {
	int start;
	FILE2 *f=(FILE2 *)file2;
	if (param==SEEK_SET) {
		start=0;
	} else if (param==SEEK_END) {
		start=f->len-1;
	} else if (param==SEEK_CUR) {
		start=f->readbyte;
	}
	int p=num+start+f->ofs;
	if (p>f->ofs+f->len || p<f->ofs) {
		char spbuf[256];
		sprintf (spbuf,"p=%d ofs=%d len=%d start=%d",p,f->ofs,f->len,start);
		MessageBox (NULL,spbuf,"OK!",MB_OK);
		return -1;
	}
	f->readbyte=num+start;
	return fseek(f->fp,p,SEEK_SET);
}
int FILE2Close (void *file2) {
	FILE2 *f=(FILE2 *)file2;
	return fclose (f->fp);
}
long FILE2Tell (void *file2) {
	FILE2 *f=(FILE2 *)file2;
	return f->readbyte;
}

BOOL APIENTRY DllMain(HANDLE hModule,DWORD ul_reason_for_call,LPVOID lpReserved);

BOOL APIENTRY DllMain( HANDLE hModule,DWORD  ul_reason_for_call,LPVOID lpReserved) {
	return TRUE;
}

